commit 41d22ec51c4190133a082197e7ff67b4741fc09b
Author: Przemyslaw Wirkus <przemyslaw.wirkus@arm.com>
Date:   Fri Aug 28 11:31:04 2020 +0100

    [PATCH PR96357][GCC][AArch64]: could not split insn UNSPEC_COND_FSUB with AArch64 SVE
    
    Problem is related to that operand 4 (In original pattern
    cond_sub<mode>_any_const) is no longer the same as operand 1, and so
    the pattern doesn't match the split condition.
    
    Pattern cond_sub<mode>_any_const is being split by this patch into two
    separate patterns:
    * Pattern cond_sub<mode>_relaxed_const now matches const_int
      SVE_RELAXED_GP operand.
    * Pattern cond_sub<mode>_strict_const now matches const_int
      SVE_STRICT_GP operand.
    * Remove aarch64_sve_pred_dominates_p condition from both patterns.
    
    gcc/ChangeLog:
    
            PR target/96357
            * config/aarch64/aarch64-sve.md
            (cond_sub<mode>_relaxed_const): Updated and renamed from
            cond_sub<mode>_any_const pattern.
            (cond_sub<mode>_strict_const): New pattern.
    
    gcc/testsuite/ChangeLog:
    
            PR target/96357
            * gcc.target/aarch64/sve/pr96357.c: New test.

diff --git a/gcc/testsuite/gcc.target/aarch64/sve/pr96357.c b/gcc/testsuite/gcc.target/aarch64/sve/pr96357.c
new file mode 100644
index 00000000000..e52867f5729
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/sve/pr96357.c
@@ -0,0 +1,25 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -march=armv8.2-a+sve" } */
+
+int d;
+
+void
+f1(char f, char *g, char *h, char *l, char *n) {
+  double i = d, j = 1.0 - f, k = j ? d : j;
+  if (k == 1.0)
+    i = 0.0;
+  *l = *n = *g = *h = i * 0.5;
+}
+
+void
+f2() {
+  int a, m, c;
+  for (c = 2048; c; c--) {
+    char b = a++;
+    f1(b, m, m + 1, m + 2, m + 3); /*{ dg-warning {passing argument [0-9]+ of 'f1' makes pointer from integer without a cast} } */
+    m += 4;
+  }
+}
+
+/* { dg-final { scan-assembler {\tmovprfx\tz[0-9]+, z[0-9]+} } } */
+/* { dg-final { scan-assembler {\tfsubr\tz[0-9]+\.d, p[0-7]/m, z[0-9]+\.d, #1.0} } } */

